PLaSK library

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Public Attributes | List of all members
plask::ReductionTo2DMesh Struct Reference

This class is a 2D mesh which wraps 3D mesh (`sourceMesh`), reduce each point of sourceMesh to 2D and translate it back by given vector (`translation`). More...

`#include <plask/mesh/transformed.hpp>`

Inheritance diagram for plask::ReductionTo2DMesh:
[legend]
Collaboration diagram for plask::ReductionTo2DMesh:
[legend]

## Public Types
enum | { SRC_DIM = 3 }
| Number of source dimensions. More...
typedef Geometry3D | SourceGeometry
| Source geometry.
typedef Geometry2DCartesian | TargetGeometry
| Target geometry.
Public Types inherited from plask::MeshD< 2 >
enum |
| Number of dimensions. More...
typedef Primitive< DIM >::DVec | LocalCoords
| Type of vector representing coordinates in local space.
typedef IndexedIterator< const MeshD< dimension >, LocalCoords > | const_iterator
| Random access iterator type which allow iterate over all points in this mesh, in order appointed by operator[].
typedef const_iterator | iterator
typedef const_iterator | Iterator

## Public Member Functions
| ReductionTo2DMesh (const shared_ptr< const MeshD< 3 > > sourceMesh, const Vec< 2, double > &translation=Primitive< 2 >::ZERO_VEC)
| ReductionTo2DMesh (const shared_ptr< const MeshD< 3 > > sourceMesh, const Vec< 3, double > &translation)
Vec< 2, double > | at (std::size_t index) const override
| Get point with given mesh index.
std::size_t | size () const override
Public Member Functions inherited from plask::MeshD< 2 >
LocalCoords | operator[] (std::size_t index) const
| Get point with given mesh index.
const_iterator | begin () const
const_iterator | end () const
| MeshD (const MeshD &PLASK_UNUSED(to_copy))
| Initialize this to be the same as `to_copy` but don't copy any changes observer.
| MeshD ()
MeshD & | operator= (const MeshD &PLASK_UNUSED(to_copy))
| Set this to be the same as `to_copy` but doesn't changed changes observer.
bool | operator== (const MeshD &to_compare) const
| Check if this mesh and `to_compare` represent the same sequence of points (have exactly the same points in the same order).
bool | operator!= (const MeshD &to_compare) const
| Check if this mesh and `to_compare` represent different sequences of points.
void | print (std::ostream &out) const override
| Print this to stream `out`.
Public Member Functions inherited from plask::Mesh
template<typename ClassT , typename methodT >
boost::signals2::connection | changedConnectMethod (ClassT *obj, methodT method, boost::signals2::connect_position at=boost::signals2::at_back)
| Connect a method to changed signal.
template<typename ClassT , typename methodT >
void | changedDisconnectMethod (ClassT *obj, methodT method)
template<typename EventT = Event, typename ... Args>
void | fireChanged (Args &&... event_constructor_params_without_source)
| Call changed with this as event source.
void | fireResized ()
| This method is called when the mesh is resized.
virtual bool | empty () const
virtual void | writeXML (XMLElement &object) const
| Write mesh to XML.
virtual | ~Mesh ()
Public Member Functions inherited from plask::Printable
virtual | ~Printable ()
std::string | str () const
| Get string representation of this using print method.
Public Member Functions inherited from plask::MeshBase
virtual | ~MeshBase ()

## Public Attributes
Vec< 2, double > | translation
const shared_ptr< const MeshD< 3 > > | sourceMesh
Public Attributes inherited from plask::Mesh
boost::signals2::signal< void(Event &)> | changed
| Changed signal, fired when mesh was changed.

## Additional Inherited Members
Protected Member Functions inherited from plask::MeshD< 2 >
virtual bool | hasSameNodes (const MeshD< dimension > &to_compare) const
| Check if this mesh and `to_compare` represent the same sequence of points (have exactly the same points in the same order).
Protected Member Functions inherited from plask::Mesh
virtual void | onChange (const Event &evt)
| This method is called when the mesh is changed, just before changed signal.

## Detailed Description

This class is a 2D mesh which wraps 3D mesh (`sourceMesh`), reduce each point of sourceMesh to 2D and translate it back by given vector (`translation`).

Definition at line 26 of file transformed.hpp.

## Member Typedef Documentation

## ◆ SourceGeometry

typedef Geometry3D plask::ReductionTo2DMesh::SourceGeometry

Source geometry.

Definition at line 29 of file transformed.hpp.

## ◆ TargetGeometry

typedef Geometry2DCartesian plask::ReductionTo2DMesh::TargetGeometry

Target geometry.

Definition at line 32 of file transformed.hpp.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

Number of source dimensions.

Enumerator
SRC_DIM |

Definition at line 35 of file transformed.hpp.

## Constructor & Destructor Documentation

## ◆ ReductionTo2DMesh() [1/2]

plask::ReductionTo2DMesh::ReductionTo2DMesh | ( | const shared_ptr< const MeshD< 3 > > | sourceMesh,
|  | const Vec< 2, double > & | translation = `Primitive<2>::ZERO_VEC`
| ) |  |
| inline

Definition at line 41 of file transformed.hpp.

## ◆ ReductionTo2DMesh() [2/2]

plask::ReductionTo2DMesh::ReductionTo2DMesh | ( | const shared_ptr< const MeshD< 3 > > | sourceMesh,
|  | const Vec< 3, double > & | translation
| ) |  |
| inline

Definition at line 44 of file transformed.hpp.

## Member Function Documentation

## ◆ at()

Vec< 2, double > plask::ReductionTo2DMesh::at | ( | std::size_t | index | ) | const
| inline override virtual

Get point with given mesh index.

Parameters

  index | index of point, from 0 to size()-1

Returns
  point with given `index`

Implements plask::MeshD< 2 >.

Definition at line 47 of file transformed.hpp.

## ◆ size()

std::size_t plask::ReductionTo2DMesh::size | ( |  | ) | const
| inline override virtual

Returns
  number of points in mesh

Implements plask::Mesh.

Definition at line 51 of file transformed.hpp.

## Member Data Documentation

## ◆ sourceMesh

const shared_ptr<const MeshD<3> > plask::ReductionTo2DMesh::sourceMesh

Definition at line 39 of file transformed.hpp.

## ◆ translation

Vec<2,double> plask::ReductionTo2DMesh::translation

Definition at line 37 of file transformed.hpp.

The documentation for this struct was generated from the following file:

- plask/mesh/transformed.hpp